Touch 2.1.1 Sencha Docs

Ext.data.proxy.Ajax

Alternate names

Ext.data.AjaxProxy
Ext.data.HttpProxy

Hierarchy

Inherited mixins

Requires

Subclasses

Files

AjaxProxy is one of the most widely-used ways of getting data into your application. It uses AJAX requests to load data from the server, usually to be placed into a Store. Let's take a look at a typical setup. Here we're going to set up a Store that has an AjaxProxy. To prepare, we'll also set up a Model:

Ext.define('User', {
    extend: 'Ext.data.Model',
    config: {
        fields: ['id', 'name', 'email']
    }
});

// The Store contains the AjaxProxy as an inline configuration
var store = Ext.create('Ext.data.Store', {
    model: 'User',
    proxy: {
        type: 'ajax',
        url : 'users.json'
    }
});

store.load();

Our example is going to load user data into a Store, so we start off by defining a Model with the fields that we expect the server to return. Next we set up the Store itself, along with a proxy configuration. This configuration was automatically turned into an Ext.data.proxy.Ajax instance, with the url we specified being passed into AjaxProxy's constructor. It's as if we'd done this:

Ext.create('Ext.data.proxy.Ajax', {
    config: {
        url: 'users.json',
        model: 'User',
        reader: 'json'
    }
});

A couple of extra configurations appeared here - model and reader. These are set by default when we create the proxy via the Store - the Store already knows about the Model, and Proxy's default Reader is JsonReader.

Now when we call store.load(), the AjaxProxy springs into action, making a request to the url we configured ('users.json' in this case). As we're performing a read, it sends a GET request to that url (see actionMethods to customize this - by default any kind of read will be sent as a GET request and any kind of write will be sent as a POST request).

Limitations

AjaxProxy cannot be used to retrieve data from other domains. If your application is running on http://domainA.com it cannot load data from http://domainB.com because browsers have a built-in security policy that prohibits domains talking to each other via AJAX.

If you need to read data from another domain and can't set up a proxy server (some software that runs on your own domain's web server and transparently forwards requests to http://domainB.com, making it look like they actually came from http://domainA.com), you can use Ext.data.proxy.JsonP and a technique known as JSON-P (JSON with Padding), which can help you get around the problem so long as the server on http://domainB.com is set up to support JSON-P responses. See JsonPProxy's introduction docs for more details.

Readers and Writers

AjaxProxy can be configured to use any type of Reader to decode the server's response. If no Reader is supplied, AjaxProxy will default to using a JsonReader. Reader configuration can be passed in as a simple object, which the Proxy automatically turns into a Reader instance:

var proxy = Ext.create('Ext.data.proxy.Ajax', {
    config: {
        model: 'User',
        reader: {
            type: 'xml',
            root: 'users'
        }
    }
});

proxy.getReader(); //returns an XmlReader instance based on the config we supplied

Url generation

AjaxProxy automatically inserts any sorting, filtering, paging and grouping options into the url it generates for each request. These are controlled with the following configuration options:

  • pageParam - controls how the page number is sent to the server (see also startParam and limitParam)
  • sortParam - controls how sort information is sent to the server
  • groupParam - controls how grouping information is sent to the server
  • filterParam - controls how filter information is sent to the server

Each request sent by AjaxProxy is described by an Operation. To see how we can customize the generated urls, let's say we're loading the Proxy with the following Operation:

var operation = Ext.create('Ext.data.Operation', {
    action: 'read',
    page  : 2
});

Now we'll issue the request for this Operation by calling read:

var proxy = Ext.create('Ext.data.proxy.Ajax', {
    url: '/users'
});

proxy.read(operation); // GET /users?page=2

Easy enough - the Proxy just copied the page property from the Operation. We can customize how this page data is sent to the server:

var proxy = Ext.create('Ext.data.proxy.Ajax', {
    url: '/users',
    pageParam: 'pageNumber'
});

proxy.read(operation); // GET /users?pageNumber=2

Alternatively, our Operation could have been configured to send start and limit parameters instead of page:

var operation = Ext.create('Ext.data.Operation', {
    action: 'read',
    start : 50,
    limit : 25
});

var proxy = Ext.create('Ext.data.proxy.Ajax', {
    url: '/users'
});

proxy.read(operation); // GET /users?start=50&limit;=25

Again we can customize this url:

var proxy = Ext.create('Ext.data.proxy.Ajax', {
    url: '/users',
    startParam: 'startIndex',
    limitParam: 'limitIndex'
});

proxy.read(operation); // GET /users?startIndex=50&limitIndex;=25

AjaxProxy will also send sort and filter information to the server. Let's take a look at how this looks with a more expressive Operation object:

var operation = Ext.create('Ext.data.Operation', {
    action: 'read',
    sorters: [
        Ext.create('Ext.util.Sorter', {
            property : 'name',
            direction: 'ASC'
        }),
        Ext.create('Ext.util.Sorter', {
            property : 'age',
            direction: 'DESC'
        })
    ],
    filters: [
        Ext.create('Ext.util.Filter', {
            property: 'eyeColor',
            value   : 'brown'
        })
    ]
});

This is the type of object that is generated internally when loading a Store with sorters and filters defined. By default the AjaxProxy will JSON encode the sorters and filters, resulting in something like this (note that the url is escaped before sending the request, but is left unescaped here for clarity):

var proxy = Ext.create('Ext.data.proxy.Ajax', {
    url: '/users'
});

proxy.read(operation); // GET /users?sort=[{"property":"name","direction":"ASC"},{"property":"age","direction":"DESC"}]&filter;=[{"property":"eyeColor","value":"brown"}]

We can again customize how this is created by supplying a few configuration options. Let's say our server is set up to receive sorting information is a format like "sortBy=name#ASC,age#DESC". We can configure AjaxProxy to provide that format like this:

 var proxy = Ext.create('Ext.data.proxy.Ajax', {
     url: '/users',
     sortParam: 'sortBy',
     filterParam: 'filterBy',

     // our custom implementation of sorter encoding - turns our sorters into "name#ASC,age#DESC"
     encodeSorters: function(sorters) {
         var length   = sorters.length,
             sortStrs = [],
             sorter, i;

         for (i = 0; i < length; i++) {
             sorter = sorters[i];

             sortStrs[i] = sorter.property + '#' + sorter.direction;
         }

         return sortStrs.join(",");
     }
 });

 proxy.read(operation); // GET /users?sortBy=name#ASC,age#DESC&filterBy;=[{"property":"eyeColor","value":"brown"}]

We can also provide a custom encodeFilters function to encode our filters.

Available since: 1.1.0

Config options

Defined By

Required Config options

The name of the Model to tie to this Proxy. ...

The name of the Model to tie to this Proxy. Can be either the string name of the Model, or a reference to the Model constructor.

Available since: 1.1.0

Defined By

Optional Config options

Specific urls to call on CRUD action methods "create", "read", "update" and "destroy". ...

Specific urls to call on CRUD action methods "create", "read", "update" and "destroy". Defaults to:

api: {
    create  : undefined,
    read    : undefined,
    update  : undefined,
    destroy : undefined
}

The url is built based upon the action being executed [create|read|update|destroy] using the commensurate api property, or if undefined default to the configured Ext.data.Store.url.

For example:

api: {
    create  : '/controller/new',
    read    : '/controller/load',
    update  : '/controller/update',
    destroy : '/controller/destroy_action'
}

If the specific URL for a given CRUD action is undefined, the CRUD action request will be directed to the configured url.

Available since: 2.0.0

True to batch actions of a particular type when synchronizing the store. ...

True to batch actions of a particular type when synchronizing the store.

Defaults to: true

Available since: 2.0.0

Comma-separated ordering 'create', 'update' and 'destroy' actions when batching. ...

Comma-separated ordering 'create', 'update' and 'destroy' actions when batching. Override this to set a different order for the batched CRUD actions to be executed in.

Defaults to: 'create,update,destroy'

Available since: 1.1.0

The event name to bubble, or an Array of event names.

The event name to bubble, or an Array of event names.

Available since: 2.0.0

The name of the cache param added to the url when using noCache. ...

The name of the cache param added to the url when using noCache.

Defaults to: "_dc"

Available since: 1.1.0

The name of the direction parameter to send in a request. ...

The name of the direction parameter to send in a request.

Note: This is only used when simpleSortMode is set to true.

Defaults to: 'dir'

Available since: 2.0.0

This can be set to false if you want to prevent the paging params to be sent along with the requests made by this proxy. ...

This can be set to false if you want to prevent the paging params to be sent along with the requests made by this proxy.

Defaults to: true

Available since: 2.0.0

Extra parameters that will be included on every request. ...

Extra parameters that will be included on every request. Individual requests with params of the same name will override these params when they are in conflict.

Defaults to: {}

Available since: 1.1.0

The name of the 'filter' parameter to send in a request. ...

The name of the 'filter' parameter to send in a request. Set this to undefined if you don't want to send a filter parameter.

Defaults to: 'filter'

Available since: 1.1.0

The name of the group parameter to send in a request. ...

The name of the group parameter to send in a request. Set this to false if you don't want to send a group parameter.

Defaults to: 'group'

Available since: 1.1.0

Ext.data.proxy.Ajax
view source
: Object
Any headers to add to the Ajax request. ...

Any headers to add to the Ajax request.

Available since: 1.1.0

The name of the limit parameter to send in a request. ...

The name of the limit parameter to send in a request. Set this to false if you don't want to send a limit parameter.

Defaults to: 'limit'

Available since: 1.1.0

A config object containing one or more event handlers to be added to this object during initialization. ...

A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.

See the Event guide for more

Note: It is bad practice to specify a listener's config when you are defining a class using Ext.define(). Instead, only specify listeners when you are instantiating your class with Ext.create().

Available since: 1.1.0

Disable caching by adding a unique parameter name to the request. ...

Disable caching by adding a unique parameter name to the request. Set to false to allow caching.

Defaults to: true

Available since: 1.1.0

The name of the page parameter to send in a request. ...

The name of the page parameter to send in a request. Set this to false if you don't want to send a page parameter.

Defaults to: 'page'

Available since: 1.1.0

Ext.data.proxy.Ajax
view source
: String
Most oData feeds require basic HTTP authentication. ...

Most oData feeds require basic HTTP authentication. This configuration allows you to specify the password.

Available since: 2.0.2

The Ext.data.reader.Reader to use to decode the server's response or data read from client. ...

The Ext.data.reader.Reader to use to decode the server's response or data read from client. This can either be a Reader instance, a config object or just a valid Reader type name (e.g. 'json', 'xml').

Defaults to: {type: 'json'}

Available since: 2.0.0

Enabling simpleSortMode in conjunction with remoteSort will only send one sort property and a direction when a remote...

Enabling simpleSortMode in conjunction with remoteSort will only send one sort property and a direction when a remote sort is requested. The directionParam and sortParam will be sent with the property name and either 'ASC' or 'DESC'.

Defaults to: false

Available since: 2.0.0

The name of the sort parameter to send in a request. ...

The name of the sort parameter to send in a request. Set this to undefined if you don't want to send a sort parameter.

Defaults to: 'sort'

Available since: 1.1.0

The name of the start parameter to send in a request. ...

The name of the start parameter to send in a request. Set this to false if you don't want to send a start parameter.

Defaults to: 'start'

Available since: 1.1.0

The number of milliseconds to wait for a response. ...

The number of milliseconds to wait for a response.

Defaults to: 30000

Available since: 1.1.0

The URL from which to request the data object.

The URL from which to request the data object.

Available since: 1.1.0

Ext.data.proxy.Ajax
view source
: String
Most oData feeds require basic HTTP authentication. ...

Most oData feeds require basic HTTP authentication. This configuration allows you to specify the username.

Available since: 2.0.2

Ext.data.proxy.Ajax
view source
: Boolean
This configuration is sometimes necessary when using cross-origin resource sharing. ...

This configuration is sometimes necessary when using cross-origin resource sharing.

Defaults to: false

Available since: 2.0.0

The Ext.data.writer.Writer to use to encode any request sent to the server or saved to client. ...

The Ext.data.writer.Writer to use to encode any request sent to the server or saved to client. This can either be a Writer instance, a config object or just a valid Writer type name (e.g. 'json', 'xml').

Defaults to: {type: 'json'}

Available since: 2.0.0

Properties

Defined By

Instance Properties

Ext.data.proxy.Ajax
view source
: Object
Mapping of action name to HTTP request method. ...

Mapping of action name to HTTP request method. In the basic AjaxProxy these are set to 'GET' for 'read' actions and 'POST' for 'create', 'update' and 'destroy' actions. The Ext.data.proxy.Rest maps these to the correct RESTful methods.

Defaults to: {create: 'POST', read: 'GET', update: 'POST', destroy: 'POST'}

Available since: 1.1.0

...

Defaults to: 'ext-'

Available since: 2.0.0

...

Defaults to: '-'

Available since: 2.0.0

...

Defaults to: /\.|[^\w\-]/g

Available since: 2.0.0

...

Defaults to: false

Available since: 2.0.0

...

Defaults to: true

Available since: 2.0.0

...

Defaults to: true

Available since: 1.1.0

...

Defaults to: true

Available since: 2.0.0

...

Defaults to: /^(?:delegate|single|delay|buffer|args|prepend)$/

Available since: 2.0.0

...

Defaults to: {id: 'observable', hooks: {destroy: 'destroy'}}

Available since: 2.0.0

...

Defaults to: 'identifiable'

Available since: 2.0.0

...

Defaults to: '#'

Available since: 2.0.0

...

Defaults to: 'observable'

Available since: 2.0.0

Get the reference to the current class from which this object was instantiated. ...

Get the reference to the current class from which this object was instantiated. Unlike statics, this.self is scope-dependent and it's meant to be used for dynamic inheritance. See statics for a detailed comparison

Ext.define('My.Cat', {
    statics: {
        speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
    },

    constructor: function() {
        alert(this.self.speciesName); // dependent on 'this'
    },

    clone: function() {
        return new this.self();
    }
});


Ext.define('My.SnowLeopard', {
    extend: 'My.Cat',
    statics: {
        speciesName: 'Snow Leopard'         // My.SnowLeopard.speciesName = 'Snow Leopard'
    }
});

var cat = new My.Cat();                     // alerts 'Cat'
var snowLeopard = new My.SnowLeopard();     // alerts 'Snow Leopard'

var clone = snowLeopard.clone();
alert(Ext.getClassName(clone));             // alerts 'My.SnowLeopard'

Available since: 2.0.0

...

Defaults to: /^([\w\-]+)$/

Available since: 2.0.0

Defined By

Static Properties

...

Defaults to: []

Available since: 2.0.0

Methods

Defined By

Instance Methods

Ext.data.proxy.Ajax
view source
new( [config] ) : Ext.data.proxy.Ajax
Note that if this HttpProxy is being used by a Store, then the Store's call to load will override any specified callb...

Note that if this HttpProxy is being used by a Store, then the Store's call to load will override any specified callback and params options. In this case, use the Store's events to modify parameters, or react to loading events.

Available since: 1.1.0

Parameters

  • config : Object (optional)

    Config object. If an options parameter is passed, the singleton Ext.Ajax object will be used to make the request.

Returns

Overrides: Ext.data.proxy.Server.constructor

( eventName, fn, [scope], [options] )
Appends an after-event handler. ...

Appends an after-event handler.

Same as addListener with order set to 'after'.

Available since: 2.0.0

Parameters

  • eventName : String/String[]/Object

    The name of the event to listen for.

  • fn : Function/String

    The method the event invokes.

  • scope : Object (optional)

    The scope for fn.

  • options : Object (optional)

    An object containing handler configuration.

( eventName, fn, [scope], [options] )
Appends a before-event handler. ...

Appends a before-event handler. Returning false from the handler will stop the event.

Same as addListener with order set to 'before'.

Available since: 2.0.0

Parameters

  • eventName : String/String[]/Object

    The name of the event to listen for.

  • fn : Function/String

    The method the event invokes.

  • scope : Object (optional)

    The scope for fn.

  • options : Object (optional)

    An object containing handler configuration.

( selector, name, fn, scope, options, order )private
...

Available since: 2.0.0

Parameters

Adds the specified events to the list of events which this Observable may fire. ...

Adds the specified events to the list of events which this Observable may fire.

This method has been deprecated since 2.0

It's no longer needed to add events before firing.

Available since: 1.1.0

Parameters

  • eventNames : Object/String...

    Either an object with event names as properties with a value of true or the first event name string if multiple event names are being passed as separate parameters.

( eventName, fn, [scope], [options], [order] )
Appends an event handler to this object. ...

Appends an event handler to this object. You can review the available handlers by looking at the 'events' section of the documentation for the component you are working with.

Combining Options

Using the options argument, it is possible to combine different types of listeners:

A delayed, one-time listener:

container.on('tap', this.handleTap, this, {
    single: true,
    delay: 100
});

Attaching multiple handlers in 1 call

The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:

container.on({
    tap  : this.onTap,
    swipe: this.onSwipe,

    scope: this // Important. Ensure "this" is correct during handler execution
});

One can also specify options for each event handler separately:

container.on({
    tap  : { fn: this.onTap, scope: this, single: true },
    swipe: { fn: button.onSwipe, scope: button }
});

See the Events Guide for more.

Available since: 1.1.0

Parameters

  • eventName : String/String[]/Object

    The name of the event to listen for. May also be an object who's property names are event names.

  • fn : Function/String

    The method the event invokes. Will be called with arguments given to fireEvent plus the options parameter described below.

  • scope : Object (optional)

    The scope (this reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.

  • options : Object (optional)

    An object containing handler configuration.

    This object may contain any of the following properties:

    • scope : Object (optional)

      The scope (this reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.

    • delay : Number (optional)

      The number of milliseconds to delay the invocation of the handler after the event fires.

    • single : Boolean (optional)

      true to add a handler to handle just the next firing of the event, and then remove itself.

    • order : String (optional)

      The order of when the listener should be added into the listener queue.

      If you set an order of before and the event you are listening to is preventable, you can return false and it will stop the event.

      Available options are before, current and after.

      Defaults to: current

    • buffer : Number (optional)

      Causes the handler to be delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

    • element : String (optional)

      Allows you to add a listener onto a element of this component using the elements reference.

      Ext.create('Ext.Component', {
          listeners: {
              element: 'element',
              tap: function() {
                  alert('element tap!');
              }
          }
      });
      

      All components have the element reference, which is the outer most element of the component. Ext.Container also has the innerElement element which contains all children. In most cases element is adequate.

    • delegate : String (optional)

      Uses Ext.ComponentQuery to delegate events to a specified query selector within this item.

      // Create a container with a two children; a button and a toolbar
      var container = Ext.create('Ext.Container', {
          items: [
              {
                  xtype: 'toolbar',
                  docked: 'top',
                  title: 'My Toolbar'
              },
              {
                 xtype: 'button',
                 text: 'My Button'
              }
          ]
      });
      
      container.on({
          // Ext.Buttons have an xtype of 'button', so we use that are a selector for our delegate
          delegate: 'button',
      
          tap: function() {
              alert('Button tapped!');
          }
      });
      
  • order : String (optional)

    The order of when the listener should be added into the listener queue. Possible values are before, current and after.

    Defaults to: 'current'

( object, eventName, [fn], [scope], [options] )deprecated
Adds listeners to any Observable object (or Element) which are automatically removed when this Component is destroyed. ...

Adds listeners to any Observable object (or Element) which are automatically removed when this Component is destroyed.

This method has been deprecated since 2.0

All listeners are now automatically managed where necessary. Simply use addListener.

Available since: 1.1.0

Parameters

  • object : Ext.mixin.Observable/HTMLElement

    The item to which to add a listener/listeners.

  • eventName : Object/String

    The event name, or an object containing event name properties.

  • fn : Function (optional)

    If the eventName parameter was an event name, this is the handler function.

  • scope : Object (optional)

    If the eventName parameter was an event name, this is the scope in which the handler function is executed.

  • options : Object (optional)

    If the eventName parameter was an event name, this is the addListener options.

Optional callback function which can be used to clean up after a request has been completed. ...

Optional callback function which can be used to clean up after a request has been completed.

Available since: 1.1.0

Parameters

...

Available since: 2.0.0

Parameters

Encode any values being sent to the server. ...

Encode any values being sent to the server. Can be overridden in subclasses.

Available since: 2.0.0

Parameters

  • value : Array

    An array of sorters/filters.

Returns

...

Available since: 2.0.0

Parameters

...

Available since: 2.0.0

Parameters

( reader, currentReader )private
...

Available since: 2.0.0

Parameters

( writer, currentWriter )private
...

Available since: 2.0.0

Parameters

Performs a batch of Operations, in the order specified by batchOrder. ...

Performs a batch of Operations, in the order specified by batchOrder. Used internally by Ext.data.Store's sync method. Example usage:

myProxy.batch({
    create : [myModel1, myModel2],
    update : [myModel3],
    destroy: [myModel4, myModel5]
});

Where the myModel* above are Model instances - in this case 1 and 2 are new instances and have not been saved before, 3 has been saved previously but needs to be updated, and 4 and 5 have already been saved but should now be destroyed.

Available since: 1.1.0

Parameters

  • options : Object

    Object containing one or more properties supported by the batch method:

    • operations : Object

      Object containing the Model instances to act upon, keyed by action name

    • listeners : Object (optional)

      Event listeners object passed straight through to the Batch - see Ext.data.Batch for details

    • batch : Ext.data.Batch/Object (optional)

      A Ext.data.Batch object (or batch config to apply to the created batch). If unspecified a default batch will be auto-created.

    • callback : Function (optional)

      The function to be called upon completion of processing the batch. The callback is called regardless of success or failure and is passed the following parameters:

      Parameters

      • batch : Ext.data.Batch

        The batch that was processed, containing all operations in their current state after processing

      • options : Object

        The options argument that was originally passed into batch

    • success : Function (optional)

      The function to be called upon successful completion of the batch. The success function is called only if no exceptions were reported in any operations. If one or more exceptions occurred then the failure function will be called instead. The success function is called with the following parameters:

      Parameters

      • batch : Ext.data.Batch

        The batch that was processed, containing all operations in their current state after processing

      • options : Object

        The options argument that was originally passed into batch

    • failure : Function (optional)

      The function to be called upon unsuccessful completion of the batch. The failure function is called when one or more operations returns an exception during processing (even if some operations were also successful). The failure function is called with the following parameters:

      Parameters

      • batch : Ext.data.Batch

        The batch that was processed, containing all operations in their current state after processing

      • options : Object

        The options argument that was originally passed into batch

    • scope : Object (optional)

      The scope in which to execute any callbacks (i.e. the this object inside the callback, success and/or failure functions). Defaults to the proxy.

Returns

Creates and returns an Ext.data.Request object based on the options passed by the Store that this Proxy is attached to. ...

Creates and returns an Ext.data.Request object based on the options passed by the Store that this Proxy is attached to.

Available since: 1.1.0

Parameters

Returns

Generates a url based on a given Ext.data.Request object. ...

Generates a url based on a given Ext.data.Request object. By default, ServerProxy's buildUrl will add the cache-buster param to the end of the url. Subclasses may need to perform additional modifications to the url.

Available since: 1.1.0

Parameters

Returns

( args ) : Objectdeprecatedprotected
Call the original method that was previously overridden with override, This method is deprecated as callParent does ...

Call the original method that was previously overridden with override,

This method is deprecated as callParent does the same thing.

Ext.define('My.Cat', {
    constructor: function() {
        alert("I'm a cat!");
    }
});

My.Cat.override({
    constructor: function() {
        alert("I'm going to be a cat!");

        var instance = this.callOverridden();

        alert("Meeeeoooowwww");

        return instance;
    }
});

var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
                          // alerts "I'm a cat!"
                          // alerts "Meeeeoooowwww"

This method has been deprecated

Use callParent instead

Available since: 2.0.0

Parameters

  • args : Array/Arguments

    The arguments, either an array or the arguments object from the current method, for example: this.callOverridden(arguments)

Returns

  • Object

    Returns the result of calling the overridden method

Call the "parent" method of the current method. ...

Call the "parent" method of the current method. That is the method previously overridden by derivation or by an override (see Ext.define).

 Ext.define('My.Base', {
     constructor: function (x) {
         this.x = x;
     },

     statics: {
         method: function (x) {
             return x;
         }
     }
 });

 Ext.define('My.Derived', {
     extend: 'My.Base',

     constructor: function () {
         this.callParent([21]);
     }
 });

 var obj = new My.Derived();

 alert(obj.x);  // alerts 21

This can be used with an override as follows:

 Ext.define('My.DerivedOverride', {
     override: 'My.Derived',

     constructor: function (x) {
         this.callParent([x*2]); // calls original My.Derived constructor
     }
 });

 var obj = new My.Derived();

 alert(obj.x);  // now alerts 42

This also works with static methods.

 Ext.define('My.Derived2', {
     extend: 'My.Base',

     statics: {
         method: function (x) {
             return this.callParent([x*2]); // calls My.Base.method
         }
     }
 });

 alert(My.Base.method(10));     // alerts 10
 alert(My.Derived2.method(10)); // alerts 20

Lastly, it also works with overridden static methods.

 Ext.define('My.Derived2Override', {
     override: 'My.Derived2',

     statics: {
         method: function (x) {
             return this.callParent([x*2]); // calls My.Derived2.method
         }
     }
 });

 alert(My.Derived2.method(10)); // now alerts 40

To override a method and replace it and also call the superclass method, use callSuper. This is often done to patch a method to fix a bug.

Available since: 2.0.0

Parameters

  • args : Array/Arguments

    The arguments, either an array or the arguments object from the current method, for example: this.callParent(arguments)

Returns

  • Object

    Returns the result of calling the parent method

This method is used by an override to call the superclass method but bypass any overridden method. ...

This method is used by an override to call the superclass method but bypass any overridden method. This is often done to "patch" a method that contains a bug but for whatever reason cannot be fixed directly.

Consider:

 Ext.define('Ext.some.Class', {
     method: function () {
         console.log('Good');
     }
 });

 Ext.define('Ext.some.DerivedClass', {
     method: function () {
         console.log('Bad');

         // ... logic but with a bug ...

         this.callParent();
     }
 });

To patch the bug in DerivedClass.method, the typical solution is to create an override:

 Ext.define('App.paches.DerivedClass', {
     override: 'Ext.some.DerivedClass',

     method: function () {
         console.log('Fixed');

         // ... logic but with bug fixed ...

         this.callSuper();
     }
 });

The patch method cannot use callParent to call the superclass method since that would call the overridden method containing the bug. In other words, the above patch would only produce "Fixed" then "Good" in the console log, whereas, using callParent would produce "Fixed" then "Bad" then "Good".

Available since: 2.1.0

Parameters

  • args : Array/Arguments

    The arguments, either an array or the arguments object from the current method, for example: this.callSuper(arguments)

Returns

  • Object

    Returns the result of calling the superclass method

( operation, eventName, fn, scope, options, order ) : Objectchainableprivate
...

Available since: 2.0.0

Parameters

Returns

Removes all listeners for this object. ...

Removes all listeners for this object.

Available since: 1.1.0

...

Available since: 1.1.0

Parameters

( operation, callback, scope )
in a ServerProxy all four CRUD operations are executed in the same manner, so we delegate to doRequest in each case ...

in a ServerProxy all four CRUD operations are executed in the same manner, so we delegate to doRequest in each case

Performs the given create operation. If you override this method in a custom Proxy, remember to always call the provided callback method when you are done with your operation.

Available since: 1.1.0

Parameters

  • operation : Ext.data.Operation

    The Operation to perform

  • callback : Function

    Callback function to be called when the Operation has completed (whether successful or not)

  • scope : Object

    Scope to execute the callback function in

Overrides: Ext.data.proxy.Proxy.create

...

Available since: 2.0.0

Parameters

Creates an event handling function which re-fires the event from this object as the passed event name. ...

Creates an event handling function which re-fires the event from this object as the passed event name.

Available since: 2.0.0

Parameters

Returns

Ext.data.proxy.Ajax
view source
( request, operation, callback, scope ) : Functionprivate
...

Available since: 1.1.0

Parameters

  • request : Ext.data.Request

    The Request object.

  • operation : Ext.data.Operation

    The Operation being executed.

  • callback : Function

    The callback function to be called when the request completes. This is usually the callback passed to doRequest.

  • scope : Object

    The scope in which to execute the callback function.

Returns

( operation, callback, scope )
Performs the given destroy operation. ...

Performs the given destroy operation. If you override this method in a custom Proxy, remember to always call the provided callback method when you are done with your operation.

Available since: 1.1.0

Parameters

  • operation : Ext.data.Operation

    The Operation to perform

  • callback : Function

    Callback function to be called when the Operation has completed (whether successful or not)

  • scope : Object

    Scope to execute the callback function in

Overrides: Ext.data.proxy.Proxy.destroy

( name, fn, scope, options ) : Booleanprivate
...

Available since: 2.0.0

Parameters

Returns

( eventName, args, action, connectedController )private
...

Available since: 2.0.0

Parameters

( name, fn, scope, options, order )private
...

Available since: 2.0.0

Parameters

Ext.data.proxy.Ajax
view source
( operation, callback, scope ) : Objectprotected
Performs Ajax request. ...

Performs Ajax request.

Available since: 1.1.0

Parameters

Returns

Overrides: Ext.data.proxy.Server.doRequest

( me, value, oldValue, options )private
...

Available since: 2.0.0

Parameters

Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present. ...

Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present. There is no implementation in the Observable base class.

Available since: 1.1.0

Parameters

  • events : String/String[]

    The event name to bubble, or an Array of event names.

Encodes the array of Ext.util.Filter objects into a string to be sent in the request url. ...

Encodes the array of Ext.util.Filter objects into a string to be sent in the request url. By default, this simply JSON-encodes the filter data

Available since: 1.1.0

Parameters

Returns

Encodes the array of Ext.util.Sorter objects into a string to be sent in the request url. ...

Encodes the array of Ext.util.Sorter objects into a string to be sent in the request url. By default, this simply JSON-encodes the sorter data

Available since: 1.1.0

Parameters

Returns

( eventName, args, fn, scope ) : Object
Fires the specified event with the passed parameters and execute a function (action) at the end if there are no liste...

Fires the specified event with the passed parameters and execute a function (action) at the end if there are no listeners that return false.

Available since: 2.0.0

Parameters

  • eventName : String

    The name of the event to fire.

  • args : Array

    Arguments to pass to handers.

  • fn : Function

    Action.

  • scope : Object

    Scope of fn.

Returns

Fires the specified event with the passed parameters (minus the event name, plus the options object passed to addList...

Fires the specified event with the passed parameters (minus the event name, plus the options object passed to addListener).

The first argument is the name of the event. Every other argument passed will be available when you listen for the event.

Example

Firstly, we set up a listener for our new event.

this.on('myevent', function(arg1, arg2, arg3, arg4, options, e) {
    console.log(arg1); // true
    console.log(arg2); // 2
    console.log(arg3); // { test: 'foo' }
    console.log(arg4); // 14
    console.log(options); // the options added when adding the listener
    console.log(e); // the event object with information about the event
});

And then we can fire off the event.

this.fireEvent('myevent', true, 2, { test: 'foo' }, 14);

An event may be set to bubble up an Observable parent hierarchy by calling enableBubble.

Available since: 1.1.0

Parameters

  • eventName : String

    The name of the event to fire.

  • args : Object...

    Variable number of parameters are passed to handlers.

Returns

  • Boolean

    Returns false if any of the handlers return false, otherwise it returns true.

Returns the value of api. ...

Returns the value of api.

Available since: 2.0.0

Returns

Returns the value of batchActions. ...

Returns the value of batchActions.

Available since: 2.0.0

Returns

Returns the value of batchOrder. ...

Returns the value of batchOrder.

Available since: 2.0.0

Returns

Returns the value of bubbleEvents. ...

Returns the value of bubbleEvents.

Available since: 2.0.0

Returns

...

Available since: 2.0.0

Returns the value of cacheString. ...

Returns the value of cacheString.

Available since: 2.0.0

Returns

...

Available since: 2.0.0

Parameters

...

Available since: 2.0.0

Returns the value of directionParam. ...

Returns the value of directionParam.

Available since: 2.0.0

Returns

Returns the value of enablePagingParams. ...

Returns the value of enablePagingParams.

Available since: 2.0.0

Returns

...

Available since: 2.0.0

Returns the value of extraParams. ...

Returns the value of extraParams.

Available since: 2.0.0

Returns

Returns the value of filterParam. ...

Returns the value of filterParam.

Available since: 2.0.0

Returns

Returns the value of groupParam. ...

Returns the value of groupParam.

Available since: 2.0.0

Returns

Ext.data.proxy.Ajax
view source
( ) : Object
Returns the value of headers. ...

Returns the value of headers.

Available since: 2.0.0

Returns

Retrieves the id of this component. ...

Retrieves the id of this component. Will autogenerate an id if one has not already been set.

Available since: 2.0.0

Returns

Returns the initial configuration passed to constructor. ...

Returns the initial configuration passed to constructor.

Available since: 2.0.0

Parameters

  • name : String (optional)

    When supplied, value for particular configuration option is returned, otherwise the full config object is returned.

Returns

Returns the value of limitParam. ...

Returns the value of limitParam.

Available since: 2.0.0

Returns

Returns the value of listeners. ...

Returns the value of listeners.

Available since: 2.0.0

Returns

...

Available since: 2.0.0

Parameters

Ext.data.proxy.Ajax
view source
( request ) : String
Returns the HTTP method name for a given request. ...

Returns the HTTP method name for a given request. By default this returns based on a lookup on actionMethods.

Available since: 1.1.0

Parameters

Returns

  • String

    The HTTP method to use (should be one of 'GET', 'POST', 'PUT' or 'DELETE').

Returns the value of model. ...

Returns the value of model.

Available since: 1.1.0

Returns

Returns the value of noCache. ...

Returns the value of noCache.

Available since: 2.0.0

Returns

...

Available since: 2.0.0

...

Available since: 2.0.0

...

Available since: 2.0.0

Returns the value of pageParam. ...

Returns the value of pageParam.

Available since: 2.0.0

Returns

Copy any sorters, filters etc into the params so they can be sent over the wire ...

Copy any sorters, filters etc into the params so they can be sent over the wire

Available since: 1.1.0

Parameters

Ext.data.proxy.Ajax
view source
( ) : String
Returns the value of password. ...

Returns the value of password.

Available since: 2.0.2

Returns

Returns the value of reader. ...

Returns the value of reader.

Available since: 1.1.0

Returns

Returns the value of simpleSortMode. ...

Returns the value of simpleSortMode.

Available since: 2.0.0

Returns

Returns the value of sortParam. ...

Returns the value of sortParam.

Available since: 2.0.0

Returns

Returns the value of startParam. ...

Returns the value of startParam.

Available since: 2.0.0

Returns

Returns the value of timeout. ...

Returns the value of timeout.

Available since: 2.0.0

Returns

...

Available since: 2.0.0

Get the url for the request taking into account the order of priority, - The request - The api - The url ...

Get the url for the request taking into account the order of priority, - The request - The api - The url

Available since: 2.0.0

Parameters

Returns

...

Available since: 2.0.0

Ext.data.proxy.Ajax
view source
( ) : String
Returns the value of username. ...

Returns the value of username.

Available since: 2.0.2

Returns

Ext.data.proxy.Ajax
view source
( ) : Boolean
Returns the value of withCredentials. ...

Returns the value of withCredentials.

Available since: 2.0.0

Returns

Returns the value of writer. ...

Returns the value of writer.

Available since: 1.1.0

Returns

...

Available since: 2.0.0

Parameters

Checks to see if this object has any listeners for a specified event ...

Checks to see if this object has any listeners for a specified event

Available since: 1.1.0

Parameters

  • eventName : String

    The name of the event to check for

Returns

  • Boolean

    True if the event is being listened for, else false

( instanceConfig ) : Objectchainableprotected
Initialize configuration for this class. ...

Initialize configuration for this class. a typical example:

Ext.define('My.awesome.Class', {
    // The default config
    config: {
        name: 'Awesome',
        isAwesome: true
    },

    constructor: function(config) {
        this.initConfig(config);
    }
});

var awesome = new My.awesome.Class({
    name: 'Super Awesome'
});

alert(awesome.getName()); // 'Super Awesome'

Available since: 2.0.0

Parameters

Returns

  • Object

    mixins The mixin prototypes as key - value pairs

...

Available since: 2.0.0

( object, eventName, [fn], [scope], [options] )deprecated
Alias for addManagedListener. ...

Alias for addManagedListener.

Adds listeners to any Observable object (or Element) which are automatically removed when this Component is destroyed.

This method has been deprecated since 2.0.0

This is now done automatically

Available since: 2.0.0

Parameters

  • object : Ext.mixin.Observable/HTMLElement

    The item to which to add a listener/listeners.

  • eventName : Object/String

    The event name, or an object containing event name properties.

  • fn : Function (optional)

    If the eventName parameter was an event name, this is the handler function.

  • scope : Object (optional)

    If the eventName parameter was an event name, this is the scope in which the handler function is executed.

  • options : Object (optional)

    If the eventName parameter was an event name, this is the addListener options.

( object, eventName, [fn], [scope] )deprecated
Alias for removeManagedListener. ...

Alias for removeManagedListener.

Adds listeners to any Observable object (or Element) which are automatically removed when this Component is destroyed.

This method has been deprecated since 2.0.0

This is now done automatically

Available since: 2.0.0

Parameters

  • object : Ext.mixin.Observable/HTMLElement

    The item to which to add a listener/listeners.

  • eventName : Object/String

    The event name, or an object containing event name properties.

  • fn : Function (optional)

    If the eventName parameter was an event name, this is the handler function.

  • scope : Object (optional)

    If the eventName parameter was an event name, this is the scope in which the handler function is executed.

( eventName, fn, [scope], [options], [order] )
Alias for addListener. ...

Alias for addListener.

Appends an event handler to this object. You can review the available handlers by looking at the 'events' section of the documentation for the component you are working with.

Combining Options

Using the options argument, it is possible to combine different types of listeners:

A delayed, one-time listener:

container.on('tap', this.handleTap, this, {
    single: true,
    delay: 100
});

Attaching multiple handlers in 1 call

The method also allows for a single argument to be passed which is a config object containing properties which specify multiple events. For example:

container.on({
    tap  : this.onTap,
    swipe: this.onSwipe,

    scope: this // Important. Ensure "this" is correct during handler execution
});

One can also specify options for each event handler separately:

container.on({
    tap  : { fn: this.onTap, scope: this, single: true },
    swipe: { fn: button.onSwipe, scope: button }
});

See the Events Guide for more.

Available since: 1.1.0

Parameters

  • eventName : String/String[]/Object

    The name of the event to listen for. May also be an object who's property names are event names.

  • fn : Function/String

    The method the event invokes. Will be called with arguments given to fireEvent plus the options parameter described below.

  • scope : Object (optional)

    The scope (this reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.

  • options : Object (optional)

    An object containing handler configuration.

    This object may contain any of the following properties:

    • scope : Object (optional)

      The scope (this reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.

    • delay : Number (optional)

      The number of milliseconds to delay the invocation of the handler after the event fires.

    • single : Boolean (optional)

      true to add a handler to handle just the next firing of the event, and then remove itself.

    • order : String (optional)

      The order of when the listener should be added into the listener queue.

      If you set an order of before and the event you are listening to is preventable, you can return false and it will stop the event.

      Available options are before, current and after.

      Defaults to: current

    • buffer : Number (optional)

      Causes the handler to be delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.

    • element : String (optional)

      Allows you to add a listener onto a element of this component using the elements reference.

      Ext.create('Ext.Component', {
          listeners: {
              element: 'element',
              tap: function() {
                  alert('element tap!');
              }
          }
      });
      

      All components have the element reference, which is the outer most element of the component. Ext.Container also has the innerElement element which contains all children. In most cases element is adequate.

    • delegate : String (optional)

      Uses Ext.ComponentQuery to delegate events to a specified query selector within this item.

      // Create a container with a two children; a button and a toolbar
      var container = Ext.create('Ext.Container', {
          items: [
              {
                  xtype: 'toolbar',
                  docked: 'top',
                  title: 'My Toolbar'
              },
              {
                 xtype: 'button',
                 text: 'My Button'
              }
          ]
      });
      
      container.on({
          // Ext.Buttons have an xtype of 'button', so we use that are a selector for our delegate
          delegate: 'button',
      
          tap: function() {
              alert('Button tapped!');
          }
      });
      
  • order : String (optional)

    The order of when the listener should be added into the listener queue. Possible values are before, current and after.

    Defaults to: 'current'

( eventName, fn, [scope], [options] )
Alias for addAfterListener. ...

Alias for addAfterListener.

Appends an after-event handler.

Same as addListener with order set to 'after'.

Available since: 2.0.0

Parameters

  • eventName : String/String[]/Object

    The name of the event to listen for.

  • fn : Function/String

    The method the event invokes.

  • scope : Object (optional)

    The scope for fn.

  • options : Object (optional)

    An object containing handler configuration.

The internal callback that the proxy uses to call any specified user callbacks after completion of a batch ...

The internal callback that the proxy uses to call any specified user callbacks after completion of a batch

Available since: 2.0.0

Parameters

( eventName, fn, [scope], [options] )
Alias for addBeforeListener. ...

Alias for addBeforeListener.

Appends a before-event handler. Returning false from the handler will stop the event.

Same as addListener with order set to 'before'.

Available since: 2.0.0

Parameters

  • eventName : String/String[]/Object

    The name of the event to listen for.

  • fn : Function/String

    The method the event invokes.

  • scope : Object (optional)

    The scope for fn.

  • options : Object (optional)

    An object containing handler configuration.

...

Available since: 2.0.0

Parameters

Overrides: Ext.Evented.onClassExtended

( names, callback, scope )private
...

Available since: 2.0.0

Parameters

...

Available since: 2.0.0

...

Available since: 2.0.0

Parameters

( success, operation, request, response, callback, scope )protected
This method handles the processing of the response and is usually overridden by subclasses to do additional processing. ...

This method handles the processing of the response and is usually overridden by subclasses to do additional processing.

Available since: 2.0.0

Parameters

  • success : Boolean

    Whether or not this request was successful

  • operation : Ext.data.Operation

    The operation we made this request for

  • request : Ext.data.Request

    The request that was made

  • response : Object

    The response that we got

  • callback : Function

    The callback to be fired onces the response is processed

  • scope : Object

    The scope in which we call the callback

( operation, callback, scope )
Performs the given read operation. ...

Performs the given read operation. If you override this method in a custom Proxy, remember to always call the provided callback method when you are done with your operation.

Available since: 1.1.0

Parameters

  • operation : Ext.data.Operation

    The Operation to perform

  • callback : Function

    Callback function to be called when the Operation has completed (whether successful or not)

  • scope : Object

    Scope to execute the callback function in

Overrides: Ext.data.proxy.Proxy.read

...

Available since: 2.0.0

Parameters

Relays selected events from the specified Observable as if the events were fired by this. ...

Relays selected events from the specified Observable as if the events were fired by this.

Available since: 1.1.0

Parameters

  • object : Object

    The Observable whose events this object is to relay.

  • events : String/Array/Object

    Array of event names to relay.

Returns

( eventName, fn, [scope], [options] )
Removes a before-event handler. ...

Removes a before-event handler.

Same as removeListener with order set to 'after'.

Available since: 2.0.0

Parameters

  • eventName : String/String[]/Object

    The name of the event the handler was associated with.

  • fn : Function/String

    The handler to remove.

  • scope : Object (optional)

    The scope originally specified for fn.

  • options : Object (optional)

    Extra options object.

( eventName, fn, [scope], [options] )
Removes a before-event handler. ...

Removes a before-event handler.

Same as removeListener with order set to 'before'.

Available since: 2.0.0

Parameters

  • eventName : String/String[]/Object

    The name of the event the handler was associated with.

  • fn : Function/String

    The handler to remove.

  • scope : Object (optional)

    The scope originally specified for fn.

  • options : Object (optional)

    Extra options object.

( selector, name, fn, scope, order )private
...

Available since: 2.0.0

Parameters

( eventName, fn, [scope], [options], [order] )
Removes an event handler. ...

Removes an event handler.

Available since: 1.1.0

Parameters

  • eventName : String/String[]/Object

    The type of event the handler was associated with.

  • fn : Function/String

    The handler to remove. This must be a reference to the function passed into the addListener call.

  • scope : Object (optional)

    The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.

  • options : Object (optional)

    Extra options object. See addListener for details.

  • order : String (optional)

    The order of the listener to remove. Possible values are before, current and after.

    Defaults to: 'current'

( object, eventName, [fn], [scope] )deprecated
Adds listeners to any Observable object (or Element) which are automatically removed when this Component is destroyed. ...

Adds listeners to any Observable object (or Element) which are automatically removed when this Component is destroyed.

This method has been deprecated since 2.0

All listeners are now automatically managed where necessary. Simply use removeListener.

Available since: 1.1.0

Parameters

  • object : Ext.mixin.Observable/HTMLElement

    The item to which to add a listener/listeners.

  • eventName : Object/String

    The event name, or an object containing event name properties.

  • fn : Function (optional)

    If the eventName parameter was an event name, this is the handler function.

  • scope : Object (optional)

    If the eventName parameter was an event name, this is the scope in which the handler function is executed.

Resumes firing events (see suspendEvents). ...

Resumes firing events (see suspendEvents).

Available since: 1.1.0

Sets the value of api. ...

Sets the value of api.

Available since: 2.0.0

Parameters

Sets the value of batchActions. ...

Sets the value of batchActions.

Available since: 2.0.0

Parameters

Sets the value of batchOrder. ...

Sets the value of batchOrder.

Available since: 2.0.0

Parameters

Sets the value of bubbleEvents. ...

Sets the value of bubbleEvents.

Available since: 2.0.0

Parameters

Sets the value of cacheString. ...

Sets the value of cacheString.

Available since: 2.0.0

Parameters

( config, applyIfNotSet ) : Ext.Basechainableprivate
...

Available since: 2.0.0

Parameters

Returns

Sets the value of directionParam. ...

Sets the value of directionParam.

Available since: 2.0.0

Parameters

Sets the value of enablePagingParams. ...

Sets the value of enablePagingParams.

Available since: 2.0.0

Parameters

( operation, response )private
Sets up an exception on the operation ...

Sets up an exception on the operation

Available since: 2.0.0

Parameters

Sets a value in the underlying extraParams. ...

Sets a value in the underlying extraParams.

Available since: 2.0.0

Parameters

  • name : String

    The key for the new value

  • value : Object

    The value

Sets the value of extraParams. ...

Sets the value of extraParams.

Available since: 2.0.0

Parameters

Sets the value of filterParam. ...

Sets the value of filterParam.

Available since: 2.0.0

Parameters

Sets the value of groupParam. ...

Sets the value of groupParam.

Available since: 2.0.0

Parameters

Ext.data.proxy.Ajax
view source
( headers )
Sets the value of headers. ...

Sets the value of headers.

Available since: 2.0.0

Parameters

...

Available since: 2.0.0

Parameters

Sets the value of limitParam. ...

Sets the value of limitParam.

Available since: 2.0.0

Parameters

Sets the value of listeners. ...

Sets the value of listeners.

Available since: 2.0.0

Parameters

Sets the value of model. ...

Sets the value of model.

Available since: 1.1.0

Parameters

Sets the value of noCache. ...

Sets the value of noCache.

Available since: 2.0.0

Parameters

Sets the value of pageParam. ...

Sets the value of pageParam.

Available since: 2.0.0

Parameters

Ext.data.proxy.Ajax
view source
( password )
Sets the value of password. ...

Sets the value of password.

Available since: 2.0.2

Parameters

Sets the value of reader. ...

Sets the value of reader.

Available since: 1.1.0

Parameters

Sets the value of simpleSortMode. ...

Sets the value of simpleSortMode.

Available since: 2.0.0

Parameters

Sets the value of sortParam. ...

Sets the value of sortParam.

Available since: 2.0.0

Parameters

Sets the value of startParam. ...

Sets the value of startParam.

Available since: 2.0.0

Parameters

Sets the value of timeout. ...

Sets the value of timeout.

Available since: 2.0.0

Parameters

Sets the value of url. ...

Sets the value of url.

Available since: 2.0.0

Parameters

Ext.data.proxy.Ajax
view source
( username )
Sets the value of username. ...

Sets the value of username.

Available since: 2.0.2

Parameters

Ext.data.proxy.Ajax
view source
( withCredentials )
Sets the value of withCredentials. ...

Sets the value of withCredentials.

Available since: 2.0.0

Parameters

Sets the value of writer. ...

Sets the value of writer.

Available since: 1.1.0

Parameters

Get the reference to the class from which this object was instantiated. ...

Get the reference to the class from which this object was instantiated. Note that unlike self, this.statics() is scope-independent and it always returns the class from which it was called, regardless of what this points to during run-time

Ext.define('My.Cat', {
    statics: {
        totalCreated: 0,
        speciesName: 'Cat' // My.Cat.speciesName = 'Cat'
    },

    constructor: function() {
        var statics = this.statics();

        alert(statics.speciesName);     // always equals to 'Cat' no matter what 'this' refers to
                                        // equivalent to: My.Cat.speciesName

        alert(this.self.speciesName);   // dependent on 'this'

        statics.totalCreated++;
    },

    clone: function() {
        var cloned = new this.self();                    // dependent on 'this'

        cloned.groupName = this.statics().speciesName;   // equivalent to: My.Cat.speciesName

        return cloned;
    }
});


Ext.define('My.SnowLeopard', {
    extend: 'My.Cat',

    statics: {
        speciesName: 'Snow Leopard'     // My.SnowLeopard.speciesName = 'Snow Leopard'
    },

    constructor: function() {
        this.callParent();
    }
});

var cat = new My.Cat();                 // alerts 'Cat', then alerts 'Cat'

var snowLeopard = new My.SnowLeopard(); // alerts 'Cat', then alerts 'Snow Leopard'

var clone = snowLeopard.clone();
alert(Ext.getClassName(clone));         // alerts 'My.SnowLeopard'
alert(clone.groupName);                 // alerts 'Cat'

alert(My.Cat.totalCreated);             // alerts 3

Available since: 2.0.0

Returns

Suspends the firing of all events. ...

Suspends the firing of all events. (see resumeEvents)

Available since: 1.1.0

( toggle, eventName, fn, scope, options, order )private
...

Available since: 2.1.0

Parameters

( eventName, fn, [scope], [options], [order] )
Alias for removeListener. ...

Alias for removeListener.

Removes an event handler.

Available since: 1.1.0

Parameters

  • eventName : String/String[]/Object

    The type of event the handler was associated with.

  • fn : Function/String

    The handler to remove. This must be a reference to the function passed into the addListener call.

  • scope : Object (optional)

    The scope originally specified for the handler. It must be the same as the scope argument specified in the original call to addListener or the listener will not be removed.

  • options : Object (optional)

    Extra options object. See addListener for details.

  • order : String (optional)

    The order of the listener to remove. Possible values are before, current and after.

    Defaults to: 'current'

( eventName, fn, [scope], [options] )
Alias for removeAfterListener. ...

Alias for removeAfterListener.

Removes a before-event handler.

Same as removeListener with order set to 'after'.

Available since: 2.0.0

Parameters

  • eventName : String/String[]/Object

    The name of the event the handler was associated with.

  • fn : Function/String

    The handler to remove.

  • scope : Object (optional)

    The scope originally specified for fn.

  • options : Object (optional)

    Extra options object.

( eventName, fn, [scope], [options] )
Alias for removeBeforeListener. ...

Alias for removeBeforeListener.

Removes a before-event handler.

Same as removeListener with order set to 'before'.

Available since: 2.0.0

Parameters

  • eventName : String/String[]/Object

    The name of the event the handler was associated with.

  • fn : Function/String

    The handler to remove.

  • scope : Object (optional)

    The scope originally specified for fn.

  • options : Object (optional)

    Extra options object.

( operation, callback, scope )
Performs the given update operation. ...

Performs the given update operation. If you override this method in a custom Proxy, remember to always call the provided callback method when you are done with your operation.

Available since: 1.1.0

Parameters

  • operation : Ext.data.Operation

    The Operation to perform

  • callback : Function

    Callback function to be called when the Operation has completed (whether successful or not)

  • scope : Object

    Scope to execute the callback function in

Overrides: Ext.data.proxy.Proxy.update

...

Available since: 2.0.0

Parameters

...

Available since: 2.0.0

Parameters

Defined By

Static Methods

( config, fullMerge )privatestatic
...

Available since: 2.0.0

Parameters

( members )chainableprivatestatic
...

Available since: 2.0.0

Parameters

( name, member )chainableprivatestatic
...

Available since: 2.0.0

Parameters

( members )chainablestatic
Add methods / properties to the prototype of this class. ...

Add methods / properties to the prototype of this class.

Ext.define('My.awesome.Cat', {
    constructor: function() {
        // ...
    }
});

 My.awesome.Cat.addMembers({
     meow: function() {
        alert('Meowww...');
     }
 });

 var kitty = new My.awesome.Cat();
 kitty.meow();

Available since: 2.0.0

Parameters

( members ) : Ext.Basechainablestatic
Add / override static properties of this class. ...

Add / override static properties of this class.

Ext.define('My.cool.Class', {
    // this.se
});

My.cool.Class.addStatics({
    someProperty: 'someValue',      // My.cool.Class.someProperty = 'someValue'
    method1: function() {  },    // My.cool.Class.method1 = function() { ... };
    method2: function() {  }     // My.cool.Class.method2 = function() { ... };
});

Available since: 2.0.0

Parameters

Returns

( xtype )chainableprivatestatic
...

Available since: 2.0.0

Parameters

( fromClass, members ) : Ext.Basechainableprivatestatic
Borrow another class' members to the prototype of this class. ...

Borrow another class' members to the prototype of this class.

Ext.define('Bank', {
    money: '$$$',
    printMoney: function() {
        alert('$$$$$$$');
    }
});

Ext.define('Thief', {
    // ...
});

Thief.borrow(Bank, ['money', 'printMoney']);

var steve = new Thief();

alert(steve.money); // alerts '$$$'
steve.printMoney(); // alerts '$$$$$$$'

Available since: 2.0.0

Parameters

  • fromClass : Ext.Base

    The class to borrow members from

  • members : Array/String

    The names of the members to borrow

Returns

( args )protectedstatic
...

Available since: 2.0.0

Parameters

Create a new instance of this Class. ...

Create a new instance of this Class.

Ext.define('My.cool.Class', {
    // ...
});

My.cool.Class.create({
    someConfig: true
});

All parameters are passed to the constructor of the class.

Available since: 2.0.0

Returns

( alias, origin )static
Create aliases for existing prototype methods. ...

Create aliases for existing prototype methods. Example:

Ext.define('My.cool.Class', {
    method1: function() {  },
    method2: function() {  }
});

var test = new My.cool.Class();

My.cool.Class.createAlias({
    method3: 'method1',
    method4: 'method2'
});

test.method3(); // test.method1()

My.cool.Class.createAlias('method5', 'method3');

test.method5(); // test.method3() -> test.method1()

Available since: 2.0.0

Parameters

( parent )privatestatic
...

Available since: 2.0.0

Parameters

Get the current class' name in string format. ...

Get the current class' name in string format.

Ext.define('My.cool.Class', {
    constructor: function() {
        alert(this.self.getName()); // alerts 'My.cool.Class'
    }
});

My.cool.Class.getName(); // 'My.cool.Class'

Available since: 2.0.0

Returns

...

Available since: 2.0.0

( name, mixinClass )privatestatic
Used internally by the mixins pre-processor ...

Used internally by the mixins pre-processor

Available since: 2.0.0

Parameters

( fn, scope )chainableprivatestatic
...

Available since: 2.0.0

Parameters

( members ) : Ext.Basechainabledeprecatedstatic
Override members of this class. ...

Override members of this class. Overridden methods can be invoked via callParent.

Ext.define('My.Cat', {
    constructor: function() {
        alert("I'm a cat!");
    }
});

My.Cat.override({
    constructor: function() {
        alert("I'm going to be a cat!");

        var instance = this.callParent(arguments);

        alert("Meeeeoooowwww");

        return instance;
    }
});

var kitty = new My.Cat(); // alerts "I'm going to be a cat!"
                          // alerts "I'm a cat!"
                          // alerts "Meeeeoooowwww"

As of 2.1, direct use of this method is deprecated. Use Ext.define instead:

Ext.define('My.CatOverride', {
    override: 'My.Cat',

    constructor: function() {
        alert("I'm going to be a cat!");

        var instance = this.callParent(arguments);

        alert("Meeeeoooowwww");

        return instance;
    }
});

The above accomplishes the same result but can be managed by the Ext.Loader which can properly order the override and its target class and the build process can determine whether the override is needed based on the required state of the target class (My.Cat).

This method has been deprecated since 2.1.0

Please use Ext.define instead

Available since: 2.0.0

Parameters

  • members : Object

    The properties to add to this class. This should be specified as an object literal containing one or more properties.

Returns

...

Available since: 2.0.0

Defined By

Events

( this, response, operation, eOpts )
Fires when the server returns an exception ...

Fires when the server returns an exception

Available since: 2.0.0

Parameters

Fires whenever the server has sent back new metadata to reconfigure the Reader. ...

Fires whenever the server has sent back new metadata to reconfigure the Reader.

Available since: 2.0.0

Parameters